<?php
/*
Plugin Name: Facebook Share and Preview
Version: 1.0
Plugin URI: http://www.studio404.it/
Description: Adds a Share link to every post and set an image and a description that Facebook can use to display the post preview.
Author: Claudio Simeone
Author URI: http://www.studio404.it/
*/

add_theme_support('post-thumbnails');
add_image_size('fb-preview', 90, 90, true);

// get image preview
function ST4_get_FB_image($post_ID){
	$post_thumbnail_id = get_post_thumbnail_id( $post_ID );
	if ($post_thumbnail_id){
		$post_thumbnail_img = wp_get_attachment_image_src( $post_thumbnail_id, 'fb-preview');
		return $post_thumbnail_img[0];
	}
}

// get post description
function ST4_get_FB_description($post){
	if ($post->post_excerpt){
		return $post->post_excerpt;
	} else {
		// post excerpt is not set, we'll take first 55 words from post content
		$excerpt_length = 55;
		// clean post content
		$text = str_replace("\r\n"," ", strip_tags(strip_shortcodes($post->post_content)));
		$words = explode(' ', $text, $excerpt_length + 1);
		if (count($words) > $excerpt_length) {
			array_pop($words);
			$excerpt = implode(' ', $words);
			return $excerpt;
		}
	}
}


function ST4FB_header(){
	global $post;
	$post_featured_image = ST4_get_FB_image($post->ID);
	$post_description = ST4_get_FB_description($post);
		
	if ( (is_single()) AND ($post_featured_image) AND ($post_description) ){ 
?>
	<meta name="title" content="<?php echo $post->post_title; ?>" />
	<meta name="description" content="<?php echo $post_description; ?>" />
	<link rel="image_src" href="<?php echo $post_featured_image; ?>" />
<?php
	}
}

/* 
	Attach the function to the head section of the blog.
	Make sure that in your header.php template file there is 
	wp_head();
	before the </head> tag
*/

add_action('wp_head','ST4FB_header');







?>